.nolist

useMB = 0		; makes RevString2+3 dramatically faster

ife useMB
	include \masm32\include\masm32rt.inc	; http://www.masm32.com/board/index.php?topic=12460
else
	include \masm32\MasmBasic\MasmBasic.inc
endif
.686
.xmm
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 1000000-1

.data
; Src	db "x", 0	; strings with len<2 let szRev crash
align 16
padd	db 0.0,0  	; Lingo's algo doesn't like that
Src	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos..", 0	; comment 0 to get 500 bytes
	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos.."
	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos.."
	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos.."
	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos..", 0
align 16
Src4Lingo	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos..", 0	; comment 0 to get 500 bytes
	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos.."
	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos.."
	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos.."
	db "This is a string, 100 characters long, that serves a variety of purposes, such as testing my algos..", 0

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	tmp$ CATSTR <print "******** timings for unaligned strings, useMB=>, %useMB, <", 13, 10>
	% echo tmp$
	tmp$
if 0
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevString
	counter_end
	print str$(eax), 9, "cycles for RevString", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src, 78)
	endif
endif
; OPT_DelLst 0

.listall
nops 9
if 1
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke crt__strrev, addr Src
	counter_end
	if useMB and 0	; put 0 to see....
		Print str$(eax), 9, "cycles for crt__strrev", 13, 10
	else	; ... how it chokes with Masm32 print
		print str$(eax), 9, "cycles for crt__strrev", 13, 10
	endif
else
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevString2a
	counter_end
	print str$(eax), 9, "cycles for RevString2a", 13, 10
endif
nops 9
.nolist

	if useMB eq 2
		PrintLine Left$(offset Src, 78)
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevString2c
	counter_end
	print str$(eax), 9, "cycles for RevString2c", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src, 78)
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevString2d
	counter_end
	print str$(eax), 9, "cycles for RevString2d", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src, 78)
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevString2e
	counter_end
	print str$(eax), 9, "cycles for RevString2e", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src, 78)
	endif

	if useMB
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call MbFlipP2
	counter_end
	print str$(eax), 9, "cycles for MbFlipP2", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src, 78)
	endif
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call RevString3
	counter_end
	print str$(eax), 9, "cycles for RevString3", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src, 78)
	endif

;	invoke Sleep, 100
;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		push offset Src
;		call RevStr
;	counter_end
;	print str$(eax), 9, "cycles for RevStr", 13, 10
;	if useMB eq 2
;		PrintLine Left$(offset Src, 78)
;	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src	; twice, yes
		push offset Src
		call szRev1
	counter_end
	print str$(eax), 9, "cycles for Masm32 szRev", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src, 78)
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
		call FlipFlopP
	counter_end
	print str$(eax), 9, "cycles for FlipFlop", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src, 78)
	endif

	print chr$(10)
	print "******** timings for 16-byte aligned strings:", 13, 10
if 0
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src4Lingo
		call RevString
	counter_end
	print str$(eax), 9, "cycles for RevString", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src4Lingo, 78)
	endif
endif
if 0
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke crt__strrev, addr Src
	counter_end
	print str$(eax), 9, "cycles for crt__strrev", 13, 10
else
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src4Lingo
		call RevString2a
	counter_end
	print str$(eax), 9, "cycles for RevString2a", 13, 10
endif
	if useMB eq 2
		PrintLine Left$(offset Src4Lingo, 78)
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src4Lingo
		call RevString2c
	counter_end
	print str$(eax), 9, "cycles for RevString2c", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src4Lingo, 78)
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src4Lingo
		call RevString2d
	counter_end
	print str$(eax), 9, "cycles for RevString2d", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src4Lingo, 78)
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src4Lingo
		call RevString2e
	counter_end
	print str$(eax), 9, "cycles for RevString2e", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src4Lingo, 78)
	endif

	if useMB
	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src4Lingo
		call MbFlipP2
	counter_end
	print str$(eax), 9, "cycles for MbFlipP2", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src, 78)
	endif
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src4Lingo
		call RevString3
	counter_end
	print str$(eax), 9, "cycles for RevString3", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src4Lingo, 78)
	endif

;	invoke Sleep, 100
;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		push offset Src4Lingo
;		call RevStr
;	counter_end
;	print str$(eax), 9, "cycles for RevStr", 13, 10
;	if useMB eq 2
;		PrintLine Left$(offset Src4Lingo, 78)
;	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src4Lingo	; twice, yes
		push offset Src4Lingo
		call szRev1
	counter_end
	print str$(eax), 9, "cycles for Masm32 szRev", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src4Lingo, 78)
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src4Lingo
		call RevLingo
	counter_end
	print str$(eax), 9, "cycles for RevLingo (GPF for non-aligned strings)", 13, 10
	if useMB eq 2
		push offset Src4Lingo
		call RevLingo
		PrintLine Left$(offset Src4Lingo, 78)
	endif

	invoke Sleep, 100
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src4Lingo
		call FlipFlopP
	counter_end
	print str$(eax), 9, "cycles for FlipFlop", 13, 10
	if useMB eq 2
		PrintLine Left$(offset Src4Lingo, 78)
	endif

	push offset Src
	call RevString2e
	print chr$(10)
	print offset Src, 13, 10
	push offset Src
	call RevString2e
	print offset Src, 13, 10, 10

	push offset Src4Lingo
	call RevLingo
	print chr$(10)
	print offset Src, 13, 10
	push offset Src4Lingo
	call RevLingo
	print offset Src4Lingo, 13, 10, 10

	print chr$(13, 10, "Sizes:", 13, 10)
	mov eax, RevString_e
	sub eax, RevString_s
	print str$(eax), 9, "RevString", 13, 10
	mov eax, RevString2a_e
	sub eax, RevString2a_s
	print str$(eax), 9, "RevString2a", 13, 10
	mov eax, RevString2b_e
	sub eax, RevString2b_s
	print str$(eax), 9, "RevString2b", 13, 10
	mov eax, RevString2c_e
	sub eax, RevString2c_s
	print str$(eax), 9, "RevString2c", 13, 10
	mov eax, RevString2d_e
	sub eax, RevString2d_s
	print str$(eax), 9, "RevString2d", 13, 10
	mov eax, RevString2e_e
	sub eax, RevString2e_s
	print str$(eax), 9, "RevString2e", 13, 10
	mov eax, MbFlipP2_endp
	sub eax, MbFlipP2_s
	print str$(eax), 9, "MbFlipP", 13, 10
	mov eax, RevString3_e
	sub eax, RevString3_s
	print str$(eax), 9, "RevString3", 13, 10
	mov eax, RevStr_e
	sub eax, RevStr_s
	print str$(eax), 9, "RevStr", 13, 10
	mov eax, szRev_e
	sub eax, szRev_s
	print str$(eax), 9, "szRev", 13, 10
	mov eax, RevLingo_e
	sub eax, RevLingo_s
	print str$(eax), 9, "RevLingo", 13, 10
	mov eax, FlipFlopP_endp
	sub eax, FlipFlopP_s
	print str$(eax), 9, "FlipFlop", 13, 10
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

align 16
RevString_s:
RevString proc
	push esi
	push edi
	mov esi, [esp+4+8]
	if 1
		invoke StrLen, esi
		lea edi, [esi+eax]		; you must know the end of the string
	else
		lea edi, [esi+len(esi)]	; you must know the end of the string - but szLen is slow
	endif
	shr eax, 3				; len div 8 - we use dwords and meet in the middle
	je @F
	.Repeat
		sub edi, 4
		mov ecx, [esi]
		mov edx, [edi]
		bswap ecx
		bswap edx
		mov [edi], ecx
		mov [esi], edx
		add esi, 4
		dec eax
	.Until Zero?
@@:	dec edi
	cmp edi, esi
	jbe @F
	movzx eax, byte ptr [esi]
	movzx edx, byte ptr [edi]
	mov [esi], dl
	mov [edi], al
	inc esi
	jmp @B
@@:	pop edi
	pop esi
	ret 4
RevString endp
RevString_e:

align 16
RevString2a_s:
RevString2a proc
	push esi
	push edi
	mov esi, [esp+4+8]
	ife useMB
		invoke StrLen, esi
		lea edi, [esi+eax-4]		; you must know the end of the string
	else
		lea edi, [esi+Len(esi)-4]	; you must know the end of the string - but szLen is slow
	endif
	cmp eax, 4
	jb @F
	.Repeat
	if 1	; 64 bytes
		mov edx, [edi]
		lodsd
		bswap edx
		mov [esi-4], edx
		bswap eax
		mov [edi], eax
		sub edi, 4
	else	; 67 bytes
		mov edx, [edi]
		mov eax, [esi]
		bswap eax
		bswap edx
		mov [edi], eax
		mov [esi], edx
		sub edi, 4
		add esi, 4
	endif
	.Until edi<esi
@@:	add edi, 4
@@:	dec edi
	cmp edi, esi
	jbe @F
	mov al, byte ptr [esi]
	mov dl, byte ptr [edi]
	mov [esi], dl
	mov [edi], al
	inc esi
	jmp @B
@@:	pop edi
	pop esi
	ret 4
RevString2a endp
RevString2a_e:

align 16
RevString2b_s:
RevString2b proc
	push esi
	push edi
	mov esi, [esp+4+8]
	ife useMB
		invoke StrLen, esi
		lea edi, [esi+eax-4]		; you must know the end of the string
	else
		lea edi, [esi+Len(esi)-4]	; you must know the end of the string - but szLen is slow
	endif
	cmp eax, 4
	jb @F
	.Repeat
	if 0	; 64 bytes
;		mov edx, [edi]
;		lodsd
;		bswap edx
;		mov [esi-4], edx
;		bswap eax
;		mov [edi], eax
;		sub edi, 4
	else	; 67 bytes
		mov edx, [edi]
		mov eax, [esi]
		bswap eax
		bswap edx
		mov [edi], eax
		mov [esi], edx
		sub edi, 4
		add esi, 4
;		if 0
;		cmp edi, esi
;		jb @F
;		mov edx, [edi]
;		mov eax, [esi]
;		bswap eax
;		bswap edx
;		mov [edi], eax
;		mov [esi], edx
;		sub edi, 4
;		add esi, 4
;		endif
	endif
	.Until edi<esi
	if 0
;	jbe @F
@@:	add edi, 4
@@:	dec edi
	cmp edi, esi
	jbe @F
	lodsb
	mov dl, byte ptr [edi]
	mov [esi-1], dl
	mov [edi], al
	jmp @B
	else
@@:	add edi, 4
@@:	dec edi
	cmp edi, esi
	jbe @F
	mov al, byte ptr [esi]
	mov dl, byte ptr [edi]
	mov [esi], dl
	mov [edi], al
	inc esi
	jmp @B
	endif
@@:	pop edi
	pop esi
	ret 4
RevString2b endp
RevString2b_e:

align 16
RevString2c_s:
RevString2c proc
	push esi
	push edi
	mov esi, [esp+4+8]
	ife useMB
		invoke StrLen, esi
		lea edi, [esi+eax-4]		; you must know the end of the string
	else
		lea edi, [esi+Len(esi)-4]	; you must know the end of the string - but szLen is slow
	endif
	cmp eax, 4
	jb @F
	.Repeat
		mov eax, [esi]
		mov edx, [edi]
		bswap eax
		bswap edx
		mov [edi], eax
		mov [esi], edx
		sub edi, 4
		add esi, 4
	.Until edi<=esi
@@:	add edi, 3
@@:	cmp edi, esi
	jbe @F
	mov al, byte ptr [esi]
	mov dl, byte ptr [edi]
	mov [esi], dl
	mov [edi], al
	inc esi
	dec edi
	jmp @B
@@:	pop edi
	pop esi
	ret 4
RevString2c endp
RevString2c_e:

align 16
RevString2d_s:
RevString2d proc
	push esi
	push edi
	mov esi, [esp+4+8]
	ife useMB
		invoke StrLen, esi
		lea edi, [esi+eax-4]	; you must know the end of the string
	else
		lea edi, [esi+Len(esi)-4]	; you must know the end of the string - but szLen is slow
	endif
	cmp eax, 4		; StrLen 3 and less?
	jb @F
	.Repeat
		mov eax, [esi]
		mov edx, [edi]
		bswap eax
		bswap edx
		mov [edi], eax
		mov [esi], edx
		sub edi, 4
		add esi, 4
	.Until edi<esi	; seems OK but less is faster than less or equal!
@@:	add edi, 3
@@:	cmp edi, esi
	jbe @F
	mov al, byte ptr [esi]
	mov dl, byte ptr [edi]
	mov [esi], dl
	mov [edi], al
	inc esi
	dec edi
	jmp @B
@@:	pop edi
	pop esi
	ret 4
RevString2d endp
RevString2d_e:

align 16
RevString2e_s:
RevString2e proc	; aka MasmBasic Flip$()
	pop edx	; ret addr
	pop eax	; lpSrc
	pushad
	xchg eax, esi	; esi=src
	ife useMB
		invoke StrLen, esi
		lea edi, [esi+eax-4]	; you must know the end of the string
	else
		lea edi, [esi+Len(esi)-4]	; you must know the end of the string - but szLen is slow
	endif
	cmp eax, 4		; StrLen 3 and less?
	jb @F
	; align 4 aka nop: no effect on P4, i.e. nop=282/171 no nops=281/172
	.Repeat
		mov eax, [esi]
		mov edx, [edi]
		bswap eax
		bswap edx
		mov [edi], eax
		mov [esi], edx
		sub edi, 4
		add esi, 4
		if 0			; absolutely no effect on P4, 22 bytes more
			.Break .if edi<=esi
			mov eax, [esi]
			mov edx, [edi]
			bswap eax
			bswap edx
			mov [edi], eax
			mov [esi], edx
			sub edi, 4
			add esi, 4
		endif
	.Until edi<=esi	; seems OK but less is faster than less or equal!
@@:	add edi, 3
@@:	cmp edi, esi
	jbe @F
	mov al, byte ptr [esi]
	mov dl, byte ptr [edi]
	mov [esi], dl
	mov [edi], al
	inc esi
	dec edi
	jmp @B
@@:	popad	; returns start address in eax
	jmp edx
RevString2e endp
RevString2e_e:

align 16
MbFlipP2_s:
if useMB
MbFlipP2 proc
	push esi
	push edi
	call MbBufferGet	; trashes only eax
	push -1	; ct for MbCopy
	push [esp+8+8]	; src
	push eax		; dest for MbCopy in tmp buffer
	xchg eax, esi	; src = tmp buffer to eax
		MbCopy PROTO :DWORD, :DWORD, :DWORD
	call MbCopy	; invoke MbCopy, eax, edx, -1
	dec eax
	push 1	; flag increase slot
	push eax	; end address on stack for MbBufferFix
	sub eax, 4
	mov edi, eax	; new dest, dword below string end
	sub eax, esi	; test Len
	jb @F			; StrLen 3 and less?
	.Repeat
		if 0
			lodsd	; mov eax, [esi]
			mov edx, [edi]
			bswap eax
			bswap edx
			mov [edi], eax
			mov [esi-4], edx
			sub edi, 4
;			add esi, 4
		else
			mov eax, [esi]
			mov edx, [edi]
			bswap eax
			bswap edx
			mov [edi], eax
			mov [esi], edx
			sub edi, 4
			add esi, 4
		endif
	.Until edi<=esi	; seems OK but less is faster than less or equal!
@@:	add edi, 3
@@:	cmp edi, esi
	jbe @F
	mov al, byte ptr [esi]
;	lodsb
	mov dl, byte ptr [edi]
	mov [esi], dl
	mov [edi], al
	inc esi
	dec edi
	jmp @B
@@:	; push 1	; flag increase slot
	; push edi	; end address on stack
	call MbBufferFix	; returns ptr to start of buffer
	pop edi
	pop esi
	retn 4
MbFlipP2 endp
endif			; end useMB
MbFlipP2_endp:

align 16
RevString3_s:
RevString3 proc
	push esi
	push edi
	mov esi, [esp+4+8]
	ife useMB
		invoke StrLen, esi
		lea edi, [esi+eax-4]		; you must know the end of the string
	elseif 0
		mov edi, esi
		xor eax, eax
		or ecx, -1
		repne scasb	; very slow, adds 300 cycles
		xchg eax, ecx
		neg eax
		sub eax, 2
		sub edi, 5
	else
		lea edi, [esi+Len(esi)-4]	; you must know the end of the string - but szLen is slow
	endif
	cmp eax, 4
	jb @F
	.Repeat
	if 0	; 64 bytes
		if 0
			mov edx, [edi]
			bswap edx
			mov eax, [esi]
			mov [esi], edx
			bswap eax
			add esi, 4
			mov [edi], eax
		else
			mov edx, [edi]
			lodsd
			bswap edx
			mov [esi-4], edx
			bswap eax
			mov [edi], eax
		endif
		sub edi, 4
	else	; 67 bytes
		mov edx, [edi]
		mov eax, [esi]
		bswap eax
		bswap edx
		mov [edi], eax
		mov [esi], edx
		sub edi, 4
		add esi, 4
	endif
	.Until edi<esi
@@:	add edi, 4
@@:	dec edi
	cmp edi, esi
	jbe @F
	mov al, byte ptr [esi]
	mov dl, byte ptr [edi]
	mov [esi], dl
	mov [edi], al
	inc esi
	jmp @B
@@:	pop edi
	pop esi
	ret 4
RevString3 endp
RevString3_e:

align 16
RevStr_s:
RevStr  proc
        push    edi
        push    esi
	if 1
	       mov     esi, [esp+4+8]
		invoke StrLen, esi
		lea edi, [esi+eax]		; you must know the end of the string
	else
	       mov     edi, [esp+4+8]
		mov     esi, edi
        		add     edi, len(edi)                ; you must know the end of the string
	endif
        shr     eax, 3                       ; len div 8 - we use dwords and meet in the middle
        jz      RevSt2

RevSt0: sub     edi,4
        mov     ecx, [esi]
        mov     edx, [edi]
        bswap   ecx
        bswap   edx
        mov     [edi], ecx
        mov     [esi], edx
        dec     eax
        lea     esi, [esi+4]
        jnz     RevSt0

        jmp short RevSt2

RevSt1: movzx   edx, byte ptr [edi]
        movzx   eax, byte ptr [esi]
        mov     [esi],dl
        mov     [edi],al
        inc     esi

RevSt2: dec     edi
        cmp     edi,esi
        ja      RevSt1

        pop     esi
        pop     edi
        ret     4
RevStr  endp
RevStr_e:

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16
szRev_s:
szRev1 proc src:DWORD,dst:DWORD

  ; ------------------------------------
  ; this version will reverses a string
  ; in a single memory buffer so it can
  ; accept the same address as both src
  ; and dst.
  ; ------------------------------------

    push esi
    push edi

    mov esi, [esp+4][8]     ; src
    mov edi, [esp+8][8]     ; dst
    xor eax, eax            ; use EAX as a counter

  ; ---------------------------------------
  ; first loop gets the buffer length and
  ; copies the first buffer into the second
  ; ---------------------------------------
 ;   @@:
 ;     movzx edx, BYTE PTR [esi+eax]       ; copy source to dest
 ;     ;; mov [edi+eax], dl
 ;     add eax, 1                          ; get the length in EAX
 ;     test edx, edx
 ;     jne @B

    invoke StrLen, esi
    cmp eax, 1
    jbe TooShort

    mov esi, [esp+8][8]                 ; put dest address in ESI
    mov edi, esi                        ; same in EDI
    ; sub eax, 1                          ; correct for exit from 1st loop <<<<<<<<<<< little bug
    lea edi, [edi+eax-1]                ; end address in edi
    shr eax, 1                          ; int divide length by 2
    neg eax                             ; invert sign
    sub esi, eax                        ; sub half len from ESI

  ; ------------------------------------------
  ; second loop swaps end pairs of bytes until
  ; it reaches the middle of the buffer
  ; ------------------------------------------
  @@:
    movzx ecx, BYTE PTR [esi+eax]       ; load end pairs
    movzx edx, BYTE PTR [edi]
    mov [esi+eax], dl                   ; swap end pairs
    mov [edi], cl
    sub edi, 1
    add eax, 1
    jnz @B                              ; exit on half length

    ;; mov eax, dst                     ; return destination address
TooShort:
    pop edi
    pop esi

    ret 8

szRev1 endp
szRev_e:

align 16
RevLingo_s:
db	 9 Dup(0cch)
RevLingo proc          ; lpBuffer:dword [url=http://www.masm32.com/board/index.php?topic=14041.msg111377#msg111377]thread[/url]
				pop				edx
				pop				ecx
				pxor			xmm0, xmm0
				mov				eax, ecx
@@:
				pcmpeqb	xmm0, [ecx]
				add				ecx, 16
				pmovmskb	edx, xmm0
				test				edx, edx
				jz					@b
				sub				ecx,	eax
				bsf				edx,	edx
				lea				edx,	[ecx+edx-16]
				cmp				edx, 4
				jb					Bytes3
				push			ebx
@@:
				mov				ecx, [eax]
				add				eax,	4
				bswap			ecx
				add				edx,	-8
				mov				ebx,	 [eax+edx]
				mov				[eax+edx], ecx
				bswap			ebx
				mov				[eax-4], ebx
				jg					@b
				pop				ebx
				jmp				dword ptr [esp-2*4]
Bytes3:
				movzx			ecx, byte  ptr [eax]
				cmp				edx, 1
				mov				byte ptr [eax+edx-1], cl
				jbe				@f
				mov				cl, byte  ptr [eax+1]
				cmp				edx, 2
				mov				byte ptr [eax+edx-2], cl
				jbe				@f
				mov				cl, byte  ptr [eax+2]
				mov				byte ptr [eax+edx-3], cl
@@:
				jmp				dword ptr [esp-2*4]
RevLingo endp 
RevLingo_e:

FlipFlopP_s:
FlipFlopP proc 	; 23 bytes; uses esi edi lpSrc=lpDest
  pop edx			; ret addr
  pop eax			; lpSrc, lpDest
  pushad
  xchg eax, esi	; esi=src
  mov edi, esi
  xor eax, eax		; we need to start with a nullbyte
  .Repeat
	push eax
	lodsb
  .Until !eax
  .Repeat
	pop eax
	stosb
  .Until !eax
  popad
  jmp edx
FlipFlopP endp
FlipFlopP_endp:

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80		; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp


end start

Intel(R) Pentium(R) 4 CPU 3.40GHz (SSE3)
******** timings for unaligned strings, useMB=1
1027    cycles for crt__strrev
322     cycles for RevString2c
297     cycles for RevString2d
284     cycles for RevString2e
378     cycles for MbFlipP2
316     cycles for RevString3
413     cycles for Masm32 szRev
1951    cycles for FlipFlop

******** timings for 16-byte aligned strings:
955     cycles for crt__strrev
189     cycles for RevString2c
163     cycles for RevString2d
178     cycles for RevString2e
368     cycles for MbFlipP2
160     cycles for RevString3
378     cycles for Masm32 szRev
174     cycles for RevLingo (GPF for non-aligned strings)
1940    cycles for FlipFlop

Intel(R) Celeron(R) M CPU        420  @ 1.60GHz (SSE3)
******** timings for unaligned strings, useMB=1
655     cycles for crt__strrev
198     cycles for RevString2c
199     cycles for RevString2d
217     cycles for RevString2e
250     cycles for MbFlipP2
200     cycles for RevString3
275     cycles for Masm32 szRev
827     cycles for FlipFlop

******** timings for 16-byte aligned strings:
655     cycles for crt__strrev
111     cycles for RevString2c
103     cycles for RevString2d
115     cycles for RevString2e
247     cycles for MbFlipP2
105     cycles for RevString3
260     cycles for Masm32 szRev
88      cycles for RevLingo (GPF for non-aligned strings)
828     cycles for FlipFlop

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]
